% Only set this to true if you want to delete all the compiled files.
clean = false;
if (clean)
    delete include/*.mex*;
end

% this might need to be changed if you have gsl installed somewhere else...
% on linux/unix, you can probably just leave them blank.
GSLFLAGS = ''; %' -I/usr/local/include/ -L/usr/local/lib/ ';

% This flag controls whether or not a non sparse array is used to represent
% histograms of words. If your dictionary size is not HUGE, you should set
% this to true for better running times. If you find that memory usage is
% concerning, you can set this to false to use a hash table, but this will
% hurt performance.
USE_FULL_ARRAYS = true;

% this might need to be changed if you have eigen somewhere else...
% the following assumes that it's installed one directory up
curdir = pwd;
IFLAGS = '';
IFLAGS = [IFLAGS ' -I' curdir '/../common/ '];

% this might need to be changed.  See here:
% http://openmp.org/wp/openmp-compilers/
OMPFLAG = ' -fopenmp ';

DFLAGS = ' -O ';
DFLAGS = [DFLAGS '-DUSELOGLIKELIHOOD '];
if (USE_FULL_ARRAYS)
    DFLAGS = [DFLAGS '-DUSEFULL '];
end

CFLAGS = [' CXXFLAGS="\$CXXFLAGS ' OMPFLAG '" CFLAGS="\$CFLAGS ' OMPFLAG '" '];
LFLAGS = [' LDFLAGS="\$LDFLAGS ' OMPFLAG '" -lgsl -lgslcblas -lm -lrt'];

cd 'include/';
try
    eval(['mex' DFLAGS IFLAGS CFLAGS LFLAGS GSLFLAGS ' computeLogStirlingTable.cpp']);

    files = ' hdp_subclusters.cpp dir_sampled.cpp dir_sampled_full.cpp categorical.cpp ';
    eval(['mex' DFLAGS IFLAGS CFLAGS LFLAGS GSLFLAGS ' hdpmm_subclusters.cpp ' files]);
    eval(['mex' DFLAGS IFLAGS CFLAGS LFLAGS GSLFLAGS ' hdpmm_subclusters_calc_likelihood.cpp ' files]);
catch exception
    cd '..';
    rethrow(exception);
end
cd '..';