#include "categorical.h"

// --------------------------------------------------------------------------
// -- categorical
// --   constructor; initializes to empty
// --------------------------------------------------------------------------
categorical::categorical() : D(0), logpi(0)
{
}

// --------------------------------------------------------------------------
// -- categorical
// --   copy constructor;
// --------------------------------------------------------------------------
categorical::categorical(const categorical& that)
{
   copy(that);
}
// --------------------------------------------------------------------------
// -- operator=
// --   assignment operator
// --------------------------------------------------------------------------
categorical& categorical::operator=(const categorical& that)
{
   if (this != &that)
   {
      if (D==that.D)
         memcpy(logpi, that.logpi, sizeof(Real)*D);
      else
      {
         cleanup();
         copy(that);
      }
   }
   return *this;
}
// --------------------------------------------------------------------------
// -- copy
// --   returns a copy of this
// --------------------------------------------------------------------------
void categorical::copy(const categorical& that)
{
   D = that.D;
   logpi = allocate_memory<Real>(D);
   memcpy(logpi, that.logpi, sizeof(Real)*D);
}

// --------------------------------------------------------------------------
// -- categorical
// --   constructor; intializes to all the values given
// --------------------------------------------------------------------------
categorical::categorical(int _D)
{
   D = _D;
   logpi = allocate_memory<Real>(D);
}

// --------------------------------------------------------------------------
// -- ~categorical
// --   destructor
// --------------------------------------------------------------------------
categorical::~categorical()
{
   cleanup();
}
// --------------------------------------------------------------------------
// -- ~cleanup
// --   deletes all the memory allocated by this
// --------------------------------------------------------------------------
void categorical::cleanup()
{
   if (logpi)   deallocate_memory(logpi);   logpi = NULL;
}

