#include "mex.h"
#include <iostream>
#include <math.h>
#include <algorithm>
#include "debugMEX.h"
#include "helperMEX.h"
#include "myfuncs.h"

#define NUMARGS 1
#define NUMOUT 1



void mexFunction(int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[])
{
   // Check for proper number of arguments
   if (nrhs != NUMARGS) {
         mexErrMsgTxt("Incorrect number of input arguments required.");
   } else if (nlhs > NUMOUT) {
         mexErrMsgTxt("Too many output arguments expected.");
   }

   checkInput(prhs[0], SCALAR,  "double"); //dictionary size, W
   int W = 1+getInput<double>(prhs[0]);
   plhs[0] = mxCreateNumericMatrix(W,W,mxDOUBLE_CLASS, mxREAL);

   arr(double) logs = getArrayInput<double>(plhs[0]);

   double minusInf = -mxGetInf();
   for (int i=0; i<W*W; i++)
      logs[i] = minusInf;
   logs[1+W] = 0;

   int m = 1;
   for (int n=1; n<W-1; n++)
      logs[n+1 + m*W] = log(n) + logs[n + m*W];

   for (int m=2; m<W; m++)
      for (int n=m-1; n<W-1; n++)
         logs[n+1 + m*W] = logsumexp(logs[n + (m-1)*W], log(n) + logs[n + m*W]);
}
