#ifndef _SAMPLE_CATEGORICAL_H_INCLUDED_
#define _SAMPLE_CATEGORICAL_H_INCLUDED_

#include "tableFuncs.h"
#include "myfuncs.h"

inline Real total_logcategorical(arr(Real) probabilities, int K, Real maxProb)
{
   Real totalProb = 0;
   for (int k=0; k<K; k++)
      totalProb += fastexp(probabilities[k]-maxProb);
   return totalProb;
}
inline int sample_logcategorical(arr(Real) probabilities, int K, Real maxProb, Real totalProb, gsl_rng *r)
{
   Real rand_num = my_rand(r) * totalProb;
   Real total = 0;
   int k;
   for (k=0; k<K; k++)
   {
      total += fastexp(probabilities[k]-maxProb);
      if (rand_num<=total)
         break;
   }
   return k;
}

inline Real convert_logcategorical(arr(Real) probabilities, int K, Real maxProb)
{
   Real totalProb = 0;
   for (int k=0; k<K; k++)
   {
      probabilities[k] = fastexp(probabilities[k]-maxProb);
      totalProb += probabilities[k];
   }
   return totalProb;
}

inline Real convert_logcategorical(arr(Real) probabilities, int K)
{
   Real maxProb = probabilities[0];
   for (int k=1; k<K; k++)
      maxProb = max(maxProb, probabilities[k]);
   return convert_logcategorical(probabilities, K, maxProb);
}

inline int sample_categorical(arr(Real) probabilities, int K, Real totalProb, gsl_rng *r)
{
   Real rand_num = my_rand(r) * totalProb;
   Real total = 0;
   int k;
   for (k=0; k<K; k++)
   {
      total += probabilities[k];
      if (rand_num<=total)
         break;
   }
   return k;
}

inline int max_categorical(arr(Real) probabilities, int K)
{
   Real maxVal = 0;
   int k;
   for (int a=0; a<K; a++)
   {
      if (probabilities[a]>maxVal)
      {
         maxVal = probabilities[a];
         k = a;
      }
   }
   return k;
}

inline int max_categorical(arr(Real) probabilities, int K, Real totalProb, gsl_rng *r)
{
   return max_categorical(probabilities, K);
}
#endif